<!DOCTYPE DM SYSTEM >

<!-- VARIABLE CLASS DECLARATION -->
<varclass name = selcls
    type = 'numeric 1'>
<varclass name = text
    type = 'char 60'>
</varclass>

<!-- VARIABLE DECLARATION -->
<varlist>
<vardcl name=begin
      varclass = selcls>
<vardcl name=comm
      varclass = selcls>
<vardcl name=dbm
      varclass = selcls>
<vardcl name=qm
      varclass = selcls>
<vardcl name=edit
      varclass = selcls>
<vardcl name=elap
      varclass = text>
<vardcl name=file
      varclass = selcls>
<vardcl name=dosa
      varclass = selcls>
<vardcl name=comma
      varclass = selcls>
<vardcl name=dbma
      varclass = selcls>
<vardcl name=qma
      varclass = selcls>
<vardcl name=edita
      varclass = selcls>
<vardcl name=filea
      varclass = selcls>
</varlist

<!-- panel definition for INIT -->
<panel name = init
       depth = 15
       keylist = init
       help=inithlp
       width = 60  >
       Option Initiation

<!-- ACTION BAR DEFINITION -->
<ab>

<!-- action bar choice FILE -->
<abc> Initialize
<pdc help=hbegin
     > Begin
    <action run=init>
<pdc help=hdos
     availvar=dosa
     >ReIPL for DOS
    <action run=dos>

<!-- action bar choice EXIT -->
<abc>Exit
<pdc >Exit   F3
     <action run=end>
<pdc >Resume
     <action run=resume>

<!-- action bar choice HELP -->
<abc>Help
<pdc >Extended Help
     <action run=help>
</ab>


<!-- Client area for INIT -->

<dtacol pmtwidth=0 >

<dtafld datavar=elap
        entwidth=60
        usage=out>

</dtacol>

 <divider>


<dtacol pmtwidth=28
      selwidth=30>

<selfld pmtloc=before  type=multi>   Check ALL items to be started
<choice name=comm1
        checkvar = comm
        availvar = comma
        help=hcomm
        >     <m>Communications Manager
        <action setvar=comm value=1>
<choice name=dbm1
        checkvar = dbm
        availvar = dbma
        help=hdbm
        >     <m>Database Manager
        <action setvar=dbm value=1>
<choice name=file1
        checkvar = file
        availvar = filea
        help=hfm
        >     <m>File Manager
        <action setvar=file value=1>
<choice name=qm1
        checkvar = qm
        availvar = qma
        help=hqm
        >     <m>Query Manager
        <ACTION SETVAR=QM VALUE=1>
<choice name=edit1
        checkvar = edit
        availvar = edita
        help=hed
        >     <m>Editor
        <action setvar=edit value=1>
</selfld>
</dtacol>

 <divider>


<!-- Push Buttons for INIT -->

<dtacol selwidth=10>
<selfld dir=horiz type=action>
 <choice  name=begin1
          checkvar = begin
          help=hbegin
          >Begin
    <action run=init>
 <choice  name=dos1
          availvar=dosa
          help=hdos
          > Dos
    <action run=dos>
 <choice> Help
    <action run=help>
</selfld>
</dtacol>
</panel>



<!-- ***************** H E L P   P A N E L S ****************** -->

<help name=inithlp> Option Initialization
    <itop roots='start starting'>Starting OS/2 Managers
    <area>
    <info>
    <p> This panel will display a list of check boxes.  These check boxes
        will be selectable for each OS/2 EE manager the system finds
        installed on your system.  If a manager is not found, its choice
        will be grayed and not selectable.
    <p> The system will remember your choices from the last time you
        used the Option Initialization procedure.  These choices will be
        displayed as prechecked.
    <p> If you have installed the dual boot feature, the DOS pushbutton
        and action bar pulldown choice will also be selectable.  In order
        to use the dual boot capability select DOS.  The first time you
        do this a message popup will appear instructing you to acknowledge
        the popup and select DOS again.  If you do this your machine will
        REBOOT immediately. NOTE: The normal message from the BOOT command
        will be suppressed!
    <p> Across the top of the screen the system will display the current
        date.  This display includes the current Julian day followed by
        the number of days remaining in the year i.e. 1/364 for the first
        of January.

    </info>
    </area>
</help>
<help name=hcomm> Communications Manager
    <itop roots='comm manager start starting'>Starting Communications Manager
    <area>
    <info>
    <p> By selecting this choice the OS/2 Communications Manager will
        be automatically started.  It will use the default
        configuration file.
    <p> Remember you may only have one instance of Communications
        Manager running a a time within your machine.
    </info>
    </area>
</help>

<help name=hdbm> Database Manager
    <itop roots='data database manager start starting'>Starting Database Manager
    <area>
    <info>
    <p> By selecting this choice the OS/2 Database Manager will
        be automatically started.
    <p> This is the database manager ONLY.  This will allow you
        to logon to the database and run programs which use dabase
        manager services.
    <p> This choice will not start the OS/2 Query Manager
    </info>
    </area>
</help>

<help name=hfm> File Manager
    <itop roots='file filer manager start starting'>Starting File Manager
    <area>
    <info>
    <p> By selecting this choice the OS/2 File Manager will
        be automatically started.
    </info>
    </area>
</help>

<HELP NAME=HQM> Query Manager
    <itop roots='data database manager query start starting'>Starting Query Manager
    <area>
    <info>
    <p> By selecting this choice both the OS/2 Database Manager and
        the OS/2 Query Manager will be automatically started.
    <p> This will allow you to logon to the database and run
        programs which use dabase manager services.  It will also
        bring up the OS/2 Query Manager for interactive use.
    </info>
    </area>
</help>
<help name=hed> Editor
    <itop roots='edit editor start starting'>Starting Your Editor
    <area>
    <info>
    <p> By selecting this choice an Editor session will
        be automatically started.
    <p> The editor which will be started is the one whose FULL path
        name you specified on the command line which started the
        Option initialization procedure.
    <p> If you did not specify any Editor on the command line the
        system will attempt to start the OS/2 system editor from its
        default instalation directory on drive C:
    </info>
    </area>
</help>

<!-- Command help -->

<help name=hbegin> BEGIN Command
    <icmd>BEGIN
    <area>
    <info>
    <p> When you activate this choice all the applications which
        you checked in the list will be started.  If you did not
        check any choices none will be started.  After each
        application has been invoked the Option Initialization screen
        will automatically be closed.
    </info>
    </area>
</help>
<help name=hdos> DOS Command
    <icmd>DOS
    <area>
    <info>
    <p> When you activate this choice all the applications which
        you checked in the list will be started.  If you did not
        check any choices none will be started.  After each
        application has been invoked the Option Initialization screen
        will automatically be closed.
    </info>
    </area>
</help>


<!-- KEY LIST TABLE -->

<keyl name=init>
  <keyi key=f3 cmd=end>
</keyl>


<!-- MESSAGE TABLE -->

<msgmbr name=inta00>
        <msg suffix=1 msgtype=warning help=dos >
        Choose OK then press DOS again to REBOOT.  ALL
        data not already saved will be LOST!
        </msg>
</msgmbr>


<!-- VALID COMMAND TABLE -->

<cmdtbl applid=ipl
      <cmd name=end>
          <cmdact action=passthru>
      <cmd name=dos>
          <cmdact action=passthru>
      <cmd name=init>
          <cmdact action=passthru>
      <cmd name=resume>
          <cmdact action=passthru>
</cmdtbl>
