/* ********************************************************************** */
/* QMEXPO version 1.0 - EXPORT Query Manager objects - 6/19/91            */
/* ********************************************************************** */
/* ********************************************************************** */
Trace 'o'
rcx = Rxfuncquery('SQLDBS')
If rcx <> 0 then
   rcy = Rxfuncadd('SQLDBS','SQLAR','SQLDBS')
rcx = Rxfuncquery('SQLEXEC')
If rcx <> 0 then
   rcy = Rxfuncadd('SQLEXEC','SQLAR','SQLEXEC')
Say "QMEXPO.CMD - version 1.0 - 6/19/91"

sample_rc = 0
call SQLDBS 'START DATABASE MANAGER'
if result<>0 then signal ERROR
if (SQLCA.SQLCODE <> -1026 & SQLCA.SQLCODE <> 0)
  then signal ERROR

Do forever
  Say ""
  Say "Please enter the database name containing the QM objects or"
  Say "Press Enter to exit."
  Pull db1
  if db1="" then leave
  else do forever
    Say "Enter name of IXF file to export objects to or"
    Say "Press Enter to select another database."
    Pull ixfname
    If ixfname = '' then leave
    Else do
      say "Exporting from" db1 "...."
      stmt = 'select * from QRWSYS.QRWSYS_OBJECT'
      crea=1
      call SQLDBS 'EXPORT :STMT FROM ' DB1 'TO ' IXFNAME 'OF IXF MESSAGES QMEXPO.LOG'
      end
      if SQLCA.SQLCODE=3107 Then Do
        say "Export errors are logged in 'QMEXPO.LOG'
        say "Do you want to see them now? Y or N"
        Pull ans
        If ans='Y' then 'TYPE QMEXPO.LOG'
      end
      else if SQLCA.SQLCODE <> 0 then signal ERROR
      if crea=1 then do
        say "**************************************"
        say "QRWSYS.QRWSYS_OBJECT has been exported."
        say "**************************************"
        say ""
      end
  end
end

result=0
signal FINISH

ERROR: result = SQLCA.SQLCODE
       say "return code:" result
       say SQLMSG
       exit result

FINISH: say 'QMEXPO finished and result =' result
        exit result

rcy = Rxfuncdrop('SQLDBS')
   If rcy <> 0 Then
     Say "RXfuncdrop SQLDBS rc =" rcy
rcy = Rxfuncdrop('SQLEXEC')
   If rcy <> 0 Then
     Say "RXfuncdrop SQLEXEC rc =" rcy
